import { SafePlugin } from '@atlaskit/editor-common/safe-plugin';
import type { ExtractInjectionAPI } from '@atlaskit/editor-common/types';
import { PluginKey } from '@atlaskit/editor-prosemirror/state';
import type { HighlightPlugin } from '../plugin';
export declare const highlightPluginKey: PluginKey<HighlightPluginState>;
export type HighlightPluginState = {
    activeColor: string | null;
    disabled: boolean;
    isPaletteOpen: boolean;
};
export declare enum HighlightPluginAction {
    CHANGE_COLOR = 0,
    SET_PALETTE = 1
}
export declare const createPlugin: ({ api, }: {
    api: ExtractInjectionAPI<HighlightPlugin> | undefined;
}) => SafePlugin<HighlightPluginState>;
